//  File: c07p089.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <iostream.h>

class Stock {
public:
   Stock( int acode = 999, double acost = 0.0, int alevel = 0 );
      // initial state
      //    if acost or alevel < 0, they are taken as 0
   int code();
      // give stock code
   double cost();
      // give unit cost
   double total_value();
      // give total value of stock
   int level();
      // give stock level
   void cost( double acost );
      // set new unit cost
      //   if acost < 0, set to 0
   void remove( int number );
      // remove number items from stock
      //    final level >= zero
   void add( int number );
      // add number to stock
      //    final level >= zero
private:
   int thecode;
   double thecost;
   int thelevel;
   void normalise();
};


Stock::Stock( int acode, double acost, int alevel )
      :thecode(acode), thecost(acost), thelevel(alevel)
{
   normalise();
}

int Stock::code()
{
   return thecode;
}

double Stock::cost()
{
   return thecost;
}

double Stock::total_value()
{
   return thecost * thelevel;
}


int Stock::level()
{
   return thelevel;
}

void Stock::cost( double acost )
{
   thecost = acost;
   normalise();
}

void Stock::remove( int number )
{
   thelevel -= number;
   normalise();
}

void Stock::add( int number )
{
   thelevel += number;
   normalise();
}

void Stock::normalise()
{
   if ( thecost < 0.0 )
      thecost = 0.0;
   if ( thelevel < 0.0 )
      thelevel = 0.0;
}

void main()
{
   Stock wigs(1,20);
   Stock springs(2,54.5);

   int newstock;
   cout << "How many wigs have been delivered? ";
   cin >> newstock;
   wigs.add(newstock);
   cout << "How many springs have been delivered? ";
   cin >> newstock;
   springs.add(newstock);

   cout << "Current stock is" << endl;
   cout << "wigs    " << wigs.level() << endl;
   cout << "springs " << springs.level() << endl;

}


