//  File: c08p108.cpp
//        rename as list.h
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#ifndef LIST_H
#define LIST_H

class List {
public:
   List();
      // Create a new list, empty() = true, end() = true
   void before( int data );
      // Insert new data before current item.
      //  New item becomes current item
      //    If end() true insert at end list
   void after( int data );
      // Insert new data after current item
      //  New item becomes current item
      //    If end() true insert at end list
   int current();
      // Data value of current item
   void next();
      // Make the next item current
   bool end();
      // Past last item?
      // if true current() undefined
   bool empty();
      // List empty?
      // If true, end() = true and current() undefined
   void top();
      // Goto first item if one exists
   void bottom();
      // Goto last item if one exists
   ~List();
      // Clean up
private:
   class Node;
   Node* theroot;
   Node* thecurrent;
   Node* theprevious;
   void clear();       // for destructor
   bool attop_empty(); // At top of list or list empty?
   bool atbottom();    // At bottom of list?
};
#endif
