//  File: c11p163.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <iostream.h>

class Window {
public:
   virtual void testpress() = 0;
   virtual ~Window(){};
};

class Callback {
public:
   virtual void doit() = 0;
   virtual ~Callback(){};
};

class Button {
public:
   Button( Window* window, Callback* acallback )
      : thewindow(window), thecallback(acallback){}
   void dummypress()
      { click(); }
private:
  Window* thewindow;
  Callback* thecallback;
  void click()
     { thecallback->doit(); }
};

class OKcallback : public Callback{
public:
   OKcallback()
      : count(0) {}
   void doit()
      { cout << "PRESSED " << count++ << endl; }
   ~OKcallback() { clog << "~OKcallback()" << endl; }
private:
   int count;
};

class MyWindow : public Window {
public:
   MyWindow()
      : okay(this,&okcallback) {}
   void testpress()
      { okay.dummypress(); }
private:
   OKcallback okcallback;
   Button okay;
};

void main()
{
   Window* mainwindow = new MyWindow;
   mainwindow->testpress();
   mainwindow->testpress();
   mainwindow->testpress();
   delete mainwindow;

}

