//  File: c12p206.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <iostream.h>
#include <iomanip.h>
#include <math.h>

const int MAXSTEPS = 8;
const double START = 0.0;
const double STEP = 1.25;

void main()
{
   const int COLw1 = 4;
   const int COLw2 = 10;
   const int COLw3 = 13;
   const int COLw4 = 13;
   const int COLw5 = 10;
   double seed = START;

   cout << setw(COLw1) << "seed"
        << setw(COLw2) << "seconds"
        << setw(COLw3) << "minutes"
        << "  " << setw(COLw4) << "hours"
        << setw(COLw5) << "days" << endl;

   for ( int steps = 0; steps < MAXSTEPS; steps++ ) {
      double secs = pow(10,seed);
      double mins = secs / 60;
      double hours = mins / 60;
      double days = hours / 24;

      long fsave = cout.flags();
      cout << setw(COLw1) << seed;
      cout.setf(ios::scientific);
      cout.precision(1);
      cout << setw(COLw2) << secs;
      cout.setf(ios::fixed);
      cout.precision(2);
      cout << setw(COLw3) << mins;
      cout.fill('0');
      cout << "  " << setw(COLw4) << hours;
      cout.fill(' ');
      cout << setw(COLw5) << days;
      cout << endl;
      cout.flags(fsave);

      seed += STEP;
   }
}