//  File: c14p214.cpp
//  The programmer's guide to C++
//  Copyright (C) 1996,1997 by Adrian P. Robson

#include <fstream.h>
#include <string>

class Stock {
public:
   Stock( int acode = 999, double acost = 0.0, int alevel = 0,
            const string& adescription = "" );
// ...
   void write( ostream& out );
   void read( istream& in );
private:
   int thecode;
   string thedescription;
   double thecost;
   int thelevel;
};

Stock::Stock( int acode, double acost, int alevel,
               const string& adescription )
   : thecode(acode), thecost(acost), thelevel(alevel),
     thedescription(adescription) {}

void Stock::write( ostream& out )
{
   out << thecode << endl;
   out << thedescription << endl;
   out << thecost << endl;
   out << thelevel << endl;
}

void Stock::read( istream& in )
{
   in >> thecode;
   getline(in,thedescription);
   in >> thecost;
   in >> thelevel;
}

void main()
{
   cout << "persistance test" << endl;

   fstream file;
   Stock item1(111,2.5,25,"Left handed widgets");
   Stock item2(222,5.6,200,"Right handed widgets");
   Stock item3(333,8.1,12,"Blue widgets");
   Stock buff;

   file.open("stock.dat",ios::out);
   if ( file.fail() ) {
      cout << "Unable to open stock file for output" << endl;
      exit(99);
   }
   item1.write(file);
   item2.write(file);
   item3.write(file);
   file.close();

   file.open("stock.dat",ios::in);
   if ( file.fail() ) {
      cout << "Unable to open stock file for input" << endl;
      exit(99);
   }
   buff.read(file);
   while ( !file.eof() ) {
      buff.write(cout);
      cout << "---------------" << endl;
      buff.read(file);
   }
   file.close();
}